Unit II21R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, II21R2_p, II21R1_p, ASB1R_p, UTII10_p;

procedure II21R(N :Integer; K :Integer; var T :Array of Real;
                var Z :Array of Real; var A :Array of Real;
                var B :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var IERR :Integer);

implementation

procedure II21R(N :Integer; K :Integer; var T :Array of Real;
                var Z :Array of Real; var A :Array of Real;
                var B :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var IERR :Integer);
var
KM1,NP2MK,KPKM1,I,J,ILEFT,MFLAG,L :Integer;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
IERR := 0;
KM1 := K-1;
NP2MK := N+2-K;
KPKM1 := K+KM1;
for I:=1 to N do
 begin
  for J:=1 to KPKM1 do
   begin
_1:
    R[(I-1)+(J-1)*N] := ZERO;
   end;
  II21R2(T[K-1],NP2MK,Z[I-1],ILEFT,MFLAG);
  ILEFT := ILEFT+KM1;
  if ( MFLAG ) < 0
   then goto _6
   else if ( MFLAG ) > 0
         then goto _2
         else goto _3;
_2:
  if ( I < N ) 
   then goto _6;
  ILEFT := N;
_3:
  II21R1(T,K,Z[I-1],ILEFT,R1,R2);
  L := ILEFT-I;
  for J:=1 to K do
   begin
    L := L+1;
_4:
    R[(I-1)+(L-1)*N] := R1[J-1];
   end;
  if ( R[(I-1)+(K-1)*N] = ZERO )
   then goto _7;
_5:
 end;
ASB1R(R,B,A,N,KM1,KM1,1,R2,IERR);
if ( IERR <> 0 )
 then goto _7;
goto _9;
_6:
IERR := 65;
goto _8;
_7:
IERR := 66;
_8:
if ( IERR <> 0 ) 
 then UTII10(IERR,21);
_9:
end;

end.
